
#include "TROOT.h"
#include "TFile.h"
#include "TTree.h"
#include "TCanvas.h"
#include "TH1F.h"
#include "TSystem.h"

#include "CDataHime.hh"

static const Int_t kUPDATE = 100;
static const Int_t N = 1000;

void example_read() 
{
   TFile *f = TFile::Open("root/madoka/run0007.root","READ");
   if(!f) return;
   TTree *t; f->GetObject("Koyomi",t);
   t->Print();

   CDataHime* data = 0;
   TBranch *bdata = 0;
   if(t->SetBranchAddress("hime",&data,&bdata) == TTree::kMissingBranch) return;

   TH1F *h = new TH1F("h","This is the CDataHime::deque_d distribution",100,-4,4);
   TCanvas *c = new TCanvas("c1","Dynamic Filling Example",200,10,700,500);

#if 1
   for (Int_t i = 0; i < N; i++) {
      Long64_t tentry = t->LoadTree(i);
      bdata->GetEntry(tentry);
      
      std::deque<CDataHime::OneData>::iterator it = data->fDequeOfOneData.begin();
      while(it != data->fDequeOfOneData.end()){
	h->Fill(it->fTime);
	++it;
      }

      if (i && (i%kUPDATE) == 0) {
         if (i == kUPDATE) h->Draw();
         c->Modified();
         c->Update();
         if (gSystem->ProcessEvents()) break;
      }
   }

   t->ResetBranchAddresses();
}
#endif

#if 0
   for (Int_t i = 0; i < N; i++) {
      Long64_t tentry = t->LoadTree(i);
      bdata->GetEntry(tentry);

      h->Reset();
      
      std::deque<CDataHime::OneData>::iterator it = data->fDequeOfOneData.begin();
      while(it != data->fDequeOfOneData.end()){
	h->Fill(it->fTime);
	++it;
      }

      if(i%kUPDATE == 0){
	h->Draw();
	c->Update();
	if (gSystem->ProcessEvents()) break;
      }
   }

   t->ResetBranchAddresses();
}
#endif
