
#include "TROOT.h"
#include "TFile.h"
#include "TTree.h"
#include "TCanvas.h"
#include "TH1F.h"
#include "TH3F.h"
#include "TGraph2D.h"
#include "TSystem.h"
#include "Buttons.h"

#include <iostream>

#include "CDataHime.hh"
#include "CDataHimeSim.hh"

void hime1() 
{
   TCanvas* canvas = new TCanvas("canvas","",200,10,700,500);

   TFile *file = TFile::Open("root/0000.root","READ");
   if(!file) return;

   TTree *tree; file->GetObject("Koyomi",tree);
   tree->Print();

   CDataHimeSim* data = 0;
   TBranch *bdata = 0;
   if(tree->SetBranchAddress("hime",&data,&bdata) == TTree::kMissingBranch) return;

   Long64_t nentries = tree->GetEntriesFast();

   for(Long64_t i=0; i<nentries; i++) {
     Long64_t entry = tree->LoadTree(i);
     bdata->GetEntry(entry);

     TGraph2D* g = new TGraph2D;
      
     Int_t point = 0;
     std::deque<CDataHimeSim::OneData>::iterator it = data->fDequeOfOneData.begin();

     if(data->fDequeOfOneData.empty()) continue;

     while(it != data->fDequeOfOneData.end()){
       std::cout << it->fPosition[0] << " " << it->fPosition[1] << " " << it->fPosition[2] << std::endl;
       g->SetPoint(point++, it->fPosition[0], it->fPosition[1], it->fPosition[2]);
       ++it;
     }

     g->SetMarkerStyle(8);
     g->SetMarkerSize(2);
     g->GetXaxis()->SetLimits(-50., 50.);
     g->GetYaxis()->SetLimits(-50., 50.);
     g->SetMinimum(700.);
     g->SetMaximum(720.);
     g->Draw("P");
     canvas->Update();

     canvas->HandleInput(kNoEvent, 0, 0);

     while (!gSystem->ProcessEvents() && canvas) {
       canvas = (TCanvas*)gROOT->GetSelectedPad();
       Int_t event = canvas->GetEvent();
       if(event == kKeyPress) break;
       if(gSystem->ProcessEvents()) break;
       gSystem->Sleep(100);
     }
   }

   tree->ResetBranchAddresses();
}

