#include "TROOT.h"
#include "TFile.h"
#include "TCanvas.h"
#include "TRandom3.h"
#include "TH1D.h"
#include "TH3D.h"
#include "TMath.h"

#include <iostream>
#include <sstream>

#include "CParticle.hh"
#include "CKinema.hh"

void Fission()
{
  int a1(1), a2(9);
  double p1_me(8.0713171);
  double p2_me(24.954264);
  double u(931.494);
  CParticle p1(p1_me+u*a1),p2(p2_me+u*a2);

  double erel(1.0);
  double kin(250.);

  TFile* f = new TFile("hist.root", "recreate");

  TH1D* hx1 = new TH1D("x1", "title", 100, -100.0, 100.0);
  TH1D* hy1 = new TH1D("y1", "title", 100, -100.0, 100.0);
  TH1D* hz1 = new TH1D("z1", "title", 100, 633.4, 833.4);
  TH3D* hxyz1 = new TH3D("xyz1", "title", 100, -100.0, 100.0, 100, -100.0, 100.0, 100, 633.4, 833.4);

  TH1D* hx2 = new TH1D("x2", "title", 100, -100.0, 100.0);
  TH1D* hy2 = new TH1D("y2", "title", 100, -100.0, 100.0);
  TH1D* hz2 = new TH1D("z2", "title", 100, 633.4, 833.4);
  TH3D* hxyz2 = new TH3D("xyz2", "title", 100, -100.0, 100.0, 100, -100.0, 100.0, 100, 633.4, 833.4);

  CKinema kinema;
  for(int i = 0; i < 10000; ++i){
    p1.k(0);
    p2.k(0);

    kinema.FissionErel(p1, p2, erel, kin);

    hx1->Fill(p1.p(0)/a1);
    hy1->Fill(p1.p(1)/a1);
    hz1->Fill(p1.p(2)/a1);
    hxyz1->Fill(p1.p(0)/a1, p1.p(1)/a1, p1.p(2)/a1);

    hx2->Fill(p2.p(0)/a2);
    hy2->Fill(p2.p(1)/a2);
    hz2->Fill(p2.p(2)/a2);
    hxyz2->Fill(p2.p(0)/a2, p2.p(1)/a2, p2.p(2)/a2);
  }

  f->Write();
}
