//
#ifndef CDataHimeSim_h
#define CDataHimeSim_h 1

#include <string>
#include <deque>

#include "TString.h"
#include "TVector3.h"

#include "CData.hh"

class CDataHimeSim : public CData
{
public:
  //each step data
  class OneData
  {
  public:
    OneData(Int_t idmother = 0, Int_t id = 0,
	    TString particlename = "", TString processname = "",
	    Double_t time = 0.,
	    Double_t edep = 0., Double_t kineticenergy = 0.,
	    TVector3 position = TVector3(), TVector3 momentum = TVector3())
      : fIdMother(idmother), fId(id),
	fParticleName(particlename), fProcessName(processname),
	fTime(time), fEdep(edep), fKineticEnergy(kineticenergy),
	fPosition(position), fMomentum(momentum)
    {;}
    ~OneData(){;}

    void Print();

    Int_t fIdMother;
    Int_t fId;
    TString fParticleName;
    TString fProcessName;
    Double_t fTime;
    Double_t fEdep;
    Double_t fKineticEnergy;
    TVector3 fPosition;
    TVector3 fMomentum;
  };

  std::deque<CDataHimeSim::OneData> fDequeOfOneData;

  //incident neutron data
  TVector3 fMomentum;

public:
  CDataHimeSim();
  CDataHimeSim(const char* name, const char* title = "");
  CDataHimeSim(const TString& name, const TString& title = "");
  CDataHimeSim(const CDataHimeSim& himehit);
  CDataHimeSim& operator=(const CDataHimeSim& rhs);
  ~CDataHimeSim();

  CDataHimeSim::OneData* Find(Int_t idmother, Int_t id);
  void Reset();

  ClassDef(CDataHimeSim, 1);
};

#endif


