
#include <iostream>

#include "CDataHime.hh"

ClassImp(CDataHime)

CDataHime::CDataHime(){;}

CDataHime::CDataHime(const char* name, const char* title) : CData(name, title)
{;}

CDataHime::CDataHime(const TString& name, const TString& title) : CData(name, title)
{;}

CDataHime::CDataHime(const CDataHime &rhs) : CData(), fDequeOfOneData(rhs.fDequeOfOneData)
{;}

CDataHime& CDataHime::operator=(const CDataHime &rhs)
{
  fDequeOfOneData = rhs.fDequeOfOneData;

  fX = rhs.fX;
  fP = rhs.fP;

  return *this;
}

CDataHime::~CDataHime(){;}

CDataHime::OneData* CDataHime::Find(Int_t idlayer, Int_t idmodule)
{
  std::deque<CDataHime::OneData>::iterator it = fDequeOfOneData.begin();  
  while(it != fDequeOfOneData.end()){
    if(it->fId[0] == idlayer && it->fId[1] == idmodule) return &(*it);
    ++it;
  }

  return 0;
}

void CDataHime::Reset()
{
  CData::Reset();
  fDequeOfOneData.clear();
}

void CDataHime::OneData::Print()
{
  std::cout << "  Layer ID:" << fId[0] << std::endl
	    << "  Module ID:" << fId[1] << std::endl
	    << "  TDC Left:" << fTL << std::endl
	    << "  TDC right:" << fTR << std::endl
	    << "  ADC Left:" << fAL << std::endl
	    << "  ADC Right:" << fAR << std::endl
	    << "  Time:" << fT << std::endl
	    << "  Energy:" << fE << std::endl
	    << "  Position:"
	    << fX.X() << ", "
	    << fX.Y() << ", "
	    << fX.Z() << std::endl;
}
