
#include <iostream>

#include "CDataHimeSim.hh"

ClassImp(CDataHimeSim)

CDataHimeSim::CDataHimeSim(){;}

CDataHimeSim::CDataHimeSim(const char* name, const char* title) : CData(name, title)
{;}

CDataHimeSim::CDataHimeSim(const TString& name, const TString& title) : CData(name, title)
{;}

CDataHimeSim::CDataHimeSim(const CDataHimeSim &rhs) : CData(),
						      fDequeOfOneData(rhs.fDequeOfOneData)
{;}

CDataHimeSim& CDataHimeSim::operator=(const CDataHimeSim &rhs)
{
  fDequeOfOneData = rhs.fDequeOfOneData;

  fMomentum = rhs.fMomentum;

  return *this;
}

CDataHimeSim::~CDataHimeSim(){;}

CDataHimeSim::OneData* CDataHimeSim::Find(Int_t idmother, Int_t id)
{
  std::deque<CDataHimeSim::OneData>::iterator it = fDequeOfOneData.begin();  
  while(it != fDequeOfOneData.end()){
    if(it->fIdMother == idmother && it->fId == id) return &(*it);
    ++it;
  }

  return 0;
}

void CDataHimeSim::Reset()
{
  CData::Reset();
  fDequeOfOneData.clear();
}

void CDataHimeSim::OneData::Print()
{
  std::cout << "  MothercopyNo.:" << fIdMother << std::endl
	    << "  copyNo.:" << fId << std::endl
	    << "  Particle Name:" << fParticleName << std::endl
	    << "  Process Name:" << fProcessName << std::endl
	    << "  Absolute Time:" << fTime << std::endl
	    << "  Energy Deposit:" << fEdep << std::endl
	    << "  Kinetic Energy:" << fKineticEnergy << std::endl
	    << "  Position:"
	    << fPosition.X() << ", "
	    << fPosition.Y() << ", "
	    << fPosition.Z() << std::endl
	    << "  Momentum:"
	    << fMomentum.X() << ", "
	    << fMomentum.Y() << ", "
	    << fMomentum.Z() << std::endl;
}
