#ifndef NMADOKA_HH
#define NMADOKA_HH

#include <string>
#include <vector>

#include "TFile.h"
#include "TTree.h"

class TBranch;
class TObject;

namespace NMadoka
{
  TFile* OpenFile(std::string filename, std::string option = "");
  TTree* CreateTree(std::string treename, std::string title);
  template <class T>
  TBranch* CreateBranch(std::string treename, std::string branchname, T* obj, Int_t bufsize = 32000, Int_t splitlevel = 99);
  TObject* FindObject(std::string name);
  void Fill(std::string treename);
  void Write();
  void CloseFile();

  TFile* GetFile();
  TTree* GetTree(std::string treename);
}

template <class T>
inline TBranch* NMadoka::CreateBranch(std::string treename, std::string branchname, T* obj, Int_t bufsize, Int_t splitlevel)  
{
  TTree* tree = GetTree(treename);
  TBranch* branch = 0;

  T** pt = new T*(obj);

  if(tree){
    branch = tree->Branch(branchname.c_str(), pt, bufsize, splitlevel);
    GetFile()->Append(obj);
  }else{
    std::cout << treename << " doesn't exist" << std::endl;    
  }

  return branch;
}

#endif
