#include "TROOT.h"
#include "TCut.h"
#include "TCutG.h"

#include <iostream>
#include <iomanip>
#include <string>

#include "CCutManager.hh"
#include "NGlobal.hh"

TCut* CCutManager::GetCut(std::string name)
{
  TObject* obj = fList->FindObject(name.c_str());
  if(obj && obj->InheritsFrom("TCut")) return (TCut*)obj;

  std::ostringstream os;
  os << FunctionName("GetCut") << name << " is not TCut";
  NGlobal::Message(os.str(), kMID);

  return 0;
}

TCut* CCutManager::GetCut(int id)
{
  std::string name = GetName(id);
  if(!Check(name)) return 0;

  return GetCut(name);
}

TCut* CCutManager::GetCut()
{
  std::string name = GetName();  
  if(!Check(name)) return 0;

  return GetCut(name);
}

TCutG* CCutManager::GetCutG(std::string name)
{
  TObject* obj = gROOT->FindObjectAny(name.c_str());
  if(obj && obj->InheritsFrom("TCutG")) return (TCutG*)obj;

  std::ostringstream os;
  os << FunctionName("GetCutG") << name << " is not TCutG";
  NGlobal::Message(os.str(), kMID);

  return 0;
}

TCutG* CCutManager::GetCutG(int id)
{
  std::string name = GetName(id);

  if(!Check(name)) return 0;

  return GetCutG(name);
}

TCutG* CCutManager::GetCutG()
{
  std::string name = GetName();  

  if(!Check(name)) return 0;

  return GetCutG(name);
}

void CCutManager::Draw(int)
{
  /* nothing */
}

std::string CCutManager::FunctionName(std::string functionname) const
{
  return "[CCutManager::" + functionname + "]$ ";
}
