
#include "CMyCalculator.hh"

#include "CBranchManager.hh"

bool CMyCalculator::Begin()
{
  if(!NAlias::branchmanager->SetValueAddress("phi", &phi)) return false;
  if(!NAlias::branchmanager->SetValueAddress("x", &x)) return false;
  if(!NAlias::branchmanager->SetValueAddress("y", &y)) return false;
  if(!NAlias::branchmanager->SetValueAddress("z", &z)) return false;

  newtree->Branch("phi_copy", &phi, "phi_copy/D");
  newtree->Branch("phi_cal", &phi_cal, "phi_cal/D");
  newtree->Branch("xy_cal", &xy_cal, "xy_cal/D");  
  newtree->Branch("zy_cal", &zy_cal, "zy_cal/D");  

  return true;
}

//if return false; do not fill this event
bool CMyCalculator::InnerLoop()
{
  phi_cal = 2.0*phi;
  xy_cal = x*y;

  if(x>0){
    zy_cal = z*y;
  }else{
    zy_cal = z*y/x;
  }

  return true;
}

bool CMyCalculator::End()
{
  /* nothing */
  return true;
}
