
#include "CInitializer.hh"
#include "CBranchManager.hh"

#include "ICalculator.hh"

void ICalculator::Calculate(std::string treename, std::string treetitle)
{
  NAlias::initializer->cd();
  newtree = new TTree(treename.c_str(), treetitle.c_str());

  std::cout << "[ICalculate::Begin]$ start calculation" << std::endl;

  if(!Begin()){
    ErrorMessage("Begin");
    return;
  }

  if(!Loop()){
    ErrorMessage("Loop");
    return;
  }

  if(!End()){
    ErrorMessage("End");
    return;
  }

  NAlias::treemanager->Push(newtree->GetName(), "on memory");
}

bool ICalculator::Loop()
{
  oldtree = NAlias::treemanager->GetTree();
  nentries = oldtree->GetEntries();

  for(Long64_t entry=0; entry<nentries; entry++) {
    oldtree->GetEntry(entry);
    if(!InnerLoop()) continue;
    newtree->Fill();
  }

  return true;
}

void ICalculator::ErrorMessage(std::string s)
{
    std::cout << std::endl;
    std::cout << "\n\n\n\n\n";
    std::cout << "************************************************************" << std::endl;
    std::cout << "[ICalculator::Calculate]$ error occur during " << s << " function" << std::endl;
    std::cout << "************************************************************" << std::endl;
    std::cout << "\n\n";
    std::cout << " don't you forget return 'true' in " << s << " function??" << std::endl;
    std::cout << "\n\n\n";
    std::cout << std::endl;
}
