#ifndef CCANVASMANAGER_HH
#define CCANVASMANAGER_HH

#include "TROOT.h"
#include "TCanvas.h"

class CCanvasManager
{
public:
  CCanvasManager() : canvasname(""), fcurrentsubpadnumber(0), fsubpadnumber(1){;}
  ~CCanvasManager(){;}

  void SetCanvas(TCanvas* canvas);
  void SetCanvas();
  TCanvas* GetCanvas();
  void SetLogx(int i);
  void SetLogy(int i);
  void SetLogz(int i);
  void Divide(Int_t nx = 1, Int_t ny = 1, Float_t xmargin = 0.01, Float_t ymargin = 0.01, Int_t color = 0);
  void cd(Int_t subpadnumber = 0);
  void NextSubpad();
  void Resize(UInt_t ww, UInt_t wh);
  void Resize();
  void SaveAs(std::string filename = "", Option_t* option = "");
  void Clear();

private:
  std::string canvasname;
  UInt_t initww;
  UInt_t initwh;

  UInt_t fcurrentsubpadnumber;
  UInt_t fsubpadnumber;

private:
  std::string FunctionName(std::string functionname);
};

#endif
