#ifndef CCONVERTERRDFTOTXT_HH
#define CCONVERTERRDFTOTXT_HH

#include <string>
#include <vector>

class CConvertFile;

class CConverterRdfToTxt
{
public:
  CConverterRdfToTxt();
  ~CConverterRdfToTxt();

public:
  int SetFile(CConvertFile* file, std::string mode);
  int Convert();
  int ConvertOnMemory(std::vector<std::vector<int> >& eventbuffer);

private:
  int ReadHeader(data_t header_block[], CConvertFile* file);
  int ReadEventBlock(data_t event_block[], CConvertFile* file);
  int ReadEnder(data_t ender_block[], CConvertFile* file);

  int WriteHeader(data_t header_block[], CConvertFile* file);
  int PrintHeader(data_t header_block[]);
  int WriteEventBlock(data_t event_block[], int i, CConvertFile* file);
  int WriteEventBlock(data_t event_block[], int i, std::vector<std::vector<int> >& eventbuffer);
  int PrintEventBlock(data_t event_block[], int i);
  int WriteEnder(data_t ender_block[], CConvertFile* file);
  int PrintEnder(data_t ender_block[]);

  int DecodeToString(data_t data_block[], char* str, int word_num, int word_len);
  int DecodeToInteger(data_t data_block[], int* data, int word_num, int word_len);

private:
  CConvertFile* fConvertFileIn;
  CConvertFile* fConvertFileOut;
};

#endif
