#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <string>

#include "GConverterRdfToTxt.hh"

#include "CConvertFile.hh"

CConvertFile::CConvertFile(std::string filename, std::string option) : m_fp(0)
{
  OpenFile(filename, option);
}

CConvertFile::~CConvertFile()
{
  if(m_fp){
    fclose(m_fp);
  }
}

int CConvertFile::OpenFile(std::string filename, std::string option)
{
  if(option == "rb" || option != "r"){
    m_fp = fopen(filename.c_str(), option.c_str());
    if(m_fp == 0){
      printf("cannot open %s\n", filename.c_str());
      return ERROR;
    }
  }else if(option == "wb" || option == "w"){
    m_fp = fopen(filename.c_str(), "r");
    if(m_fp != 0){
      printf("all ready exist %s\n", filename.c_str());
      return ERROR;
    }else{
      m_fp = fopen(filename.c_str(), option.c_str());
      if(m_fp == 0){
	printf("cannot open %s\n", filename.c_str());
	return ERROR;
      }
    }
  }else{
    printf("only rb, r, w wb\n"); 
    return ERROR;
  }
  
  return OK;
}

bool CConvertFile::IsOpen()
{
  if(m_fp != 0){
    return true;
  }else{
    return false;
  }
}

int CConvertFile::read_one_block(data_t data_block[])
{
  fread(data_block, sizeof(data_t), BLOCK_SIZE/sizeof(data_t), m_fp);
  if(feof(m_fp)){
    puts("end of file");
    return END_OF_FILE;
  }/*end of file*/
  return OK;
}

int CConvertFile::seek_back_one_block()
{
  fseek(m_fp, -BLOCK_SIZE, SEEK_CUR);
  return OK;
}

int CConvertFile::write_word(std::string buf)
{
  fprintf(m_fp, "%s", buf.c_str());
  return OK;
}

int CConvertFile::write_word(int buf)
{
  fprintf(m_fp, "%d", buf);
  return OK;
 }
