#ifndef CEVENTLOOP_HH
#define CEVENTLOOP_HH

#include <string>

class CEventLoop
{
public:
  CEventLoop()
    : eventloopcounter(0)
{
  sleeptime = 10;
  updaterate = 10;
}
  ~CEventLoop(){;}

public:
  template<class T>
  void EventLoop(T funcobj);

private:
  unsigned eventloopcounter;
  int sleeptime;
  int updaterate;
};

#include "TROOT.h"
#include "TSystem.h"
#include "TCanvas.h"
#include "TPad.h"
#include "Buttons.h"

#include <iostream>

#include "CDynamicFunction.hh"

template<class T>
inline void CEventLoop::EventLoop(T funcobj)
{
  TCanvas* canvas = NAlias::canvasmanager->GetCanvas();

  if(!canvas){
    std::cout << "\ncanvas doesn't exist\n" << std::endl;
    return;
  }

  canvas->HandleInput(kNoEvent, canvas->GetEventX(), canvas->GetEventY());
  int event((int)kNoEvent);

  while (!gSystem->ProcessEvents() && canvas) {
    ++eventloopcounter;
    canvas = (TCanvas*)gROOT->GetSelectedPad();
    event = canvas->GetEvent();
    if(funcobj(event, canvas)) return;
    if(eventloopcounter%updaterate == 0) canvas->Update();
    gSystem->Sleep(sleeptime);
  }
}

//template<class T>
//inline void CEventLoop::EventLoop(T funcobj)
//{
//  //  std::cout << "aaa" << std::endl;
//
//  //  TCanvas* canvas = NAlias::canvasmanager->GetCanvas();
//
//  //  TPad* pad((TPad*)gROOT->GetSelectedPad());
//  TPad* pad((TPad*)gPad);
//  //  TSeqCollection* tsc = gROOT->GetListOfCanvases();
//  //  TPad* pad = (TCanvas*)tsc->Last();
//
//  //  std::cout << "bbb" << std::endl;
//
//  if(!pad){
//    std::cout << "\ncanvas doesn't exist\n" << std::endl;
//    return;
//  }
//
//  //  std::cout << "ccc" << std::endl;
//
//  //  ((TCanvas*)pad)->HandleInput(kNoEvent, pad->GetEventX(), pad->GetEventY());
//  int event((int)kNoEvent);
//
//  //  std::cout << "ddd" << std::endl;
//
//  while (!gSystem->ProcessEvents() && pad) {
//    ++eventloopcounter;
//    pad = (TPad*)gROOT->GetSelectedPad();
//    event = pad->GetEvent();
//    //    event = gPad->GetEvent();
//    //    if(eventloopcounter == 1) std::cout << std::endl;
//
//    //  std::cout << "eee" << std::endl;
//
//    if(funcobj(event, pad)) return;
//    if(eventloopcounter%updaterate == 0) pad->Update();
//    gSystem->Sleep(sleeptime);
//  }
//}

#endif
