#ifndef CSIMPLEFUNCTION_HH
#define CSIMPLEFUNCTION_HH

//#include "TFitResult.h"
//#include "TFitResultPtr.h"

class TH1D;
class TProfile;
class TFitResultPtr;

class CCanvasManager;
class CHistManager;

namespace NAlias
{
  extern CCanvasManager* canvasmanager;
  extern CHistManager* histmanager;
}

class CSimpleFunction
{
public:
  CSimpleFunction(){;}
  ~CSimpleFunction(){;}  

  TFitResultPtr Fit(const char* formula, Option_t* option = "", Option_t* goption = "", Double_t xmin = 0, Double_t xmax = 0);
  TFitResultPtr FitPolynomial(int n = 1, Option_t* option = "", Option_t* goption = "", Double_t xmin = 0, Double_t xmax = 0);
  TFitResultPtr FitExponential(Option_t* option = "", Option_t* goption = "", Double_t xmin = 0,  Double_t xmax = 0);
  TFitResultPtr FitGaussian(Option_t* option = "", Option_t* goption = "", Double_t xmin = 0,  Double_t xmax = 0);
  TFitResultPtr FitLandau(Option_t* option = "", Option_t* goption = "", Double_t xmin = 0,  Double_t xmax = 0);

  TProfile* ProfileX(Int_t firstybin = 1, Int_t lastybin = -1, Option_t* option = "");
  TProfile* ProfileY(Int_t firstxbin = 1, Int_t lastxbin = -1, Option_t* option = "");
  TH1D* ProjectionX(Int_t firstybin = 0, Int_t lastybin = -1, Option_t* option = "");
  TH1D* ProjectionY(Int_t firstxbin = 0, Int_t lastxbin = -1, Option_t* option = "");
  TH1D* BanY(double firsty, double lasty, Option_t* option = "");
  TH1D* BanX(double firstx, double lastx, Option_t* option = "");

private:
  std::string FunctionName(std::string functionname) const;
};

#endif
