//included by CDynamicFunction.cc

double CDynamicFunction::FCircle::xval;
double CDynamicFunction::FCircle::yval;
double CDynamicFunction::FCircle::r1val;
double CDynamicFunction::FCircle::r2val;

void CDynamicFunction::Circle(double& x, double& y, double& r1, double& r2)
{
  std::cout << "[CDynamicFunction::Circle]$ select center of Circle"
	    << std::endl;
  XYValue(FCircle::xval, FCircle::yval);

  std::cout << "[CDynamicFunction::Circle]$ select radius of Circle"
	    << std::endl;
  CEventLoop eventloop;
  eventloop.EventLoop(CDynamicFunction::FCircle());
  x = FCircle::xval;
  y = FCircle::yval;
  r1 = FCircle::r1val;
  r2 = FCircle::r2val;
}

void CDynamicFunction::Circle()
{
  double x, y, r1, r2;
  Circle(x, y, r1, r2);
}

bool CDynamicFunction::FCircle::operator()(Int_t event, TPad* pad)
{
  static TEllipse* a(0);

  if(event == kKeyPress){
    std::cout << std::endl;
    a = 0;
    return true;
  }

  Int_t px = pad->GetEventX();
  Int_t py = pad->GetEventY();
  Double_t x = pad->AbsPixeltoX(px); 
  Double_t y = pad->AbsPixeltoY(py); 
  Double_t r1 = std::abs(x - xval);
  Double_t r2 = std::abs(y - yval);
  r1val = r1;
  r2val = r2;

  if(!a){
    a = new TEllipse(xval, yval, r1, r2);
    a->SetFillStyle(0);
    a->SetLineWidth(2);
  }

  a->SetR1(r1);
  a->SetR2(r2);
  a->Draw();

  std::cout.setf(std::ios::scientific);
  std::cout << "\r" << space
	    << "\r  rx:" << std::setprecision(2) << r1
	    << ", ry:" << std::setprecision(2) << r2;
  std::cout << std::flush;
  std::cout.unsetf(std::ios::scientific);

  return false;
}

