//included by CDynamicFunction.cc

double CDynamicFunction::FXValue::xval(0);

void CDynamicFunction::XValue(double& x)
{
  SelectPad();
  CEventLoop eventloop;
  eventloop.EventLoop(CDynamicFunction::FXValue());
  x = FXValue::xval;
}

void CDynamicFunction::XValue()
{
  std::cout << "[CDynamicFunction::XValue]$ press any key to quit" << std::endl;
  double x;
  XValue(x);
}

bool CDynamicFunction::FXValue::operator()(Int_t event, TPad* pad)
{
  static TObject* select(0);
  static TLine* l(0);

  if(event == kKeyPress){
    std::cout << std::endl;
    l = 0;
    select = 0;
    return true;
  }

  Int_t px = pad->GetEventX();
  Double_t x = pad->AbsPixeltoX(px); 
  xval = x;
  double y1 = pad->GetY1();
  double y2 = pad->GetY2();
  if(!l){
    l = new TLine(x, y1, x, y2);
  }

  l->SetX1(x);
  l->SetX2(x);
  l->Draw();

  std::cout.setf(std::ios::scientific);
  std::cout << "\r" << space
	    << "\r  x:" << std::setprecision(2) << x;
  std::cout.unsetf(std::ios::scientific);
  if(select && select->InheritsFrom("TH1")){
    TH1* h = (TH1*)select;
    Int_t bin = h->FindBin(x);
    Double_t content = h->GetBinContent(bin);
    std::cout << ", bin:" << bin;
    std::cout.setf(std::ios::scientific);
    std::cout << ", content:" << std::setprecision(2) << content;
    std::cout << std::flush;
    std::cout.unsetf(std::ios::scientific);
  }else{
    select = pad->GetSelected();
    std::cout << ", bin:---"
	      << ", content:---";
    std::cout << std::flush;
  }
  return false;
}

