//included by CDynamicFunction.cc

double CDynamicFunction::FXYValue::xval(0);
double CDynamicFunction::FXYValue::yval(0);

void CDynamicFunction::XYValue(double& x, double& y)
{
  SelectPad();
  CEventLoop eventloop;
  eventloop.EventLoop(CDynamicFunction::FXYValue());
  x = FXYValue::xval;
  y = FXYValue::yval;
}

void CDynamicFunction::XYValue()
{
  std::cout << "[CDynamicFunction::XYValue]$ press any key to quit" << std::endl;
  double x,y;
  XYValue(x, y);
}

bool CDynamicFunction::FXYValue::operator()(Int_t event, TPad* pad)
{
  static TObject* select(0);
  static TLine* lx(0);
  static TLine* ly(0);

  if(event == kKeyPress){
    std::cout << std::endl;
    lx = 0;
    ly = 0;
    return true;
  }

  Int_t px = pad->GetEventX();
  Int_t py = pad->GetEventY();
  Double_t x = pad->AbsPixeltoX(px); 
  Double_t y = pad->AbsPixeltoY(py); 
  xval = x;
  yval = y;
  double x1 = pad->GetX1();
  double x2 = pad->GetX2();
  double y1 = pad->GetY1();
  double y2 = pad->GetY2();
  if(!lx){
    lx = new TLine(x, y1, x, y2);
  }
  if(!ly){
    ly = new TLine(x1, y, x2, y);
  }

  lx->SetX1(x);
  lx->SetX2(x);
  lx->Draw();
  ly->SetY1(y);
  ly->SetY2(y);
  ly->Draw();

  std::cout.setf(std::ios::scientific);
  std::cout << "\r" << space
	    << "\r  x:" << std::setprecision(2) << x
	    << ", y:" << std::setprecision(2) << y;
  std::cout.unsetf(std::ios::scientific);
  if(select && select->InheritsFrom("TH1")){
    TH1* h = (TH1*)select;
    Int_t bin = h->FindBin(x, y);
    Double_t content = h->GetBinContent(bin);
    std::cout << ", xbin:" << bin%(h->GetNbinsX()+2)
	      << ", ybin:" << bin/(h->GetNbinsX()+2);
    std::cout.setf(std::ios::scientific);
    std::cout << ", content:" << std::setprecision(2) << content;
    std::cout << std::flush;
    std::cout.unsetf(std::ios::scientific);
  }else{
    select = pad->GetSelected();
    std::cout << ", bin:---"
	      << ", content:---";
    std::cout << std::flush;
  }

  return false;
}

